/*
 * Author: Radovan Cerveny
 */

#ifndef STEALTH_ALLOCATOR_HPP_
#define STEALTH_ALLOCATOR_HPP_

#include <memory>
#include "../measurements/MeasurementNew.hpp"

namespace measurements {

template < typename T >
class stealth_allocator : public std::allocator < T > {
public:
	using pointer = T *;
	using size_type = size_t;

	pointer allocate ( size_type n ) {
		return static_cast < pointer > ( operator new( n * sizeof ( T ), false ) );
	}

	void deallocate ( pointer ptr, size_type ) {
		operator delete( ptr, false );
	}

	template < typename U >
	struct rebind { using other = stealth_allocator < U >; };

};

}

#endif /* STEALTH_ALLOCATOR_HPP_ */
