/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_ENGINE_HPP_
#define MEASUREMENT_ENGINE_HPP_

#include "MeasurementTypes.hpp"
#include "MeasurementFrame.hpp"
#include "MeasurementResults.hpp"

namespace measurements {

class MeasurementEngine {
	measurements::stealth_vector < unsigned > frame_idx_stack;
	measurements::stealth_vector < MeasurementFrame > frames;

	MeasurementEngine ( );

public:
	void push_measurement_frame ( measurements::stealth_string, measurements::Type );
	void pop_measurement_frame ( );
	void reset_measurements ( );
	MeasurementResults get_results ( ) const;

	template < typename Hint >
	void hint ( Hint );

	~MeasurementEngine ( );

	static MeasurementEngine INSTANCE;
	static bool OPERATIONAL;
};

}

#endif /* MEASUREMENT_ENGINE_HPP_ */
