/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_FRAME_HPP_
#define MEASUREMENT_FRAME_HPP_

#include <chrono>
#include <sstream>
#include <deque>
#include "../sax/Token.h"
#include "MeasurementTypes.hpp"
#include "frames/TimeDataFrame.hpp"
#include "frames/MemoryDataFrame.hpp"
#include "frames/CounterDataFrame.hpp"

namespace measurements {

struct MeasurementFrame {
	measurements::stealth_string name;
	measurements::Type			 type;
	unsigned					 parent_idx;

	measurements::stealth_vector < unsigned > sub_idxs;

	TimeDataFrame	 time;
	MemoryDataFrame	 memory;
	CounterDataFrame counter;

	MeasurementFrame ( measurements::stealth_string, measurements::Type, unsigned );
	static void xml_tokens ( std::deque < sax::Token > &, unsigned, const measurements::stealth_vector < MeasurementFrame > & );
};

std::ostream & operator <<( std::ostream &, const MeasurementFrame & );
}

#endif /* MEASUREMENT_FRAME_HPP_ */
