/*
 * Author: Radovan Cerveny
 */

#ifndef TIME_DATA_FRAME_HPP_
#define TIME_DATA_FRAME_HPP_

#include <chrono>
#include <deque>
#include "../../sax/Token.h"
#include "../MeasurementTypes.hpp"

namespace measurements {

struct MeasurementFrame;

struct TimeDataFrame {
	std::chrono::time_point < std::chrono::high_resolution_clock > start;

	std::chrono::microseconds duration;
	std::chrono::microseconds real_duration;

	static void init ( unsigned, measurements::stealth_vector < MeasurementFrame > & );
	static void update ( unsigned, measurements::stealth_vector < MeasurementFrame > & );
	static void xml_tokens ( std::deque < sax::Token > &, unsigned, const measurements::stealth_vector < MeasurementFrame > & );
};

std::ostream & operator <<( std::ostream &, const std::chrono::microseconds & );
std::ostream & operator <<( std::ostream &, const TimeDataFrame & );
}

#endif /* TIME_DATA_FRAME_HPP_ */
