/*
 * Author: Radovan Cerveny
 */

#include "measurements.hpp"

namespace measurements {

void start ( measurements::stealth_string name, measurements::Type type ) {
	if ( MeasurementEngine::OPERATIONAL )
		MeasurementEngine::INSTANCE.push_measurement_frame ( std::move ( name ), type );
}

void end ( ) {
	if ( MeasurementEngine::OPERATIONAL )
		MeasurementEngine::INSTANCE.pop_measurement_frame ( );
}

void reset ( ) {
	if ( MeasurementEngine::OPERATIONAL )
		MeasurementEngine::INSTANCE.reset_measurements ( );
}

MeasurementResults results ( ) {
	if ( MeasurementEngine::OPERATIONAL )
		return MeasurementEngine::INSTANCE.get_results ( );
	else
		return MeasurementResults ( );
}

template < typename Hint >
void hint ( Hint hint ) {
	if ( MeasurementEngine::OPERATIONAL )
		MeasurementEngine::INSTANCE.hint ( std::move ( hint ) );
}

template void hint < MemoryHint > ( MemoryHint );
template void hint < CounterHint > ( CounterHint );
}
