/*
 * Object.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef OBJECT_H_
#define OBJECT_H_

#include "../base/WrapperBase.hpp"
#include "ObjectBase.h"

namespace alib {

/**
 * Wrapper around object.
 */
class Object : public alib::WrapperBase < ObjectBase > {
	using alib::WrapperBase < ObjectBase >::WrapperBase;

public:
	const static std::string XML_TAG_NAME_REF;
};

} /* namespace alib */

namespace std {

template < >
struct compare < alib::Object > {
	int operator ()( const alib::Object & first, const alib::Object & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* OBJECT_H_ */
