/*
 * Container.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef CONTAINER_H_
#define CONTAINER_H_

#include <base/WrapperBase.hpp>
#include "ContainerBase.h"

namespace container {

/**
 * Wrapper around containers.
 */
class Container : public alib::WrapperBase < ContainerBase > {
	using alib::WrapperBase < ContainerBase >::WrapperBase;

public:
	const static std::string XML_TAG_NAME_REF;
};

} /* namespace container */

namespace std {

template < >
struct compare < container::Container > {
	int operator ()( const container::Container & first, const container::Container & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* CONTAINER_H_ */
